#P4685. GukiZ hates Boxes

    ID: 2252 传统题 2000ms 256MiB 尝试: 0 已通过: 0 难度: (无) 上传者: 标签>基础算法二分贪心模拟CodeForces

GukiZ hates Boxes

GukiZ hates Boxes

题面翻译

nn个位置(1n)(1\sim n),第ii个位置上有aia_i个箱子。有mm个人,开始在00位置(即在11号位置左边),每一秒钟每个人都可以选择搬走自己位置上的一个箱子或向前走一步(即从位置ii走到位置i+1i+1)。问最少需要多少时间才可以将箱子全部搬完。

输入第一行两个正整数n,m(n,m105)n, m(n, m\le 10^5),第二行nn个整数ai(0ai109)a_i(0\le a_i\le 10^9)

输出一行表示答案。

题目描述

Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

In total there are n n piles of boxes, arranged in a line, from left to right, i i -th pile ( 1<=i<=n 1<=i<=n ) containing ai a_{i} boxes. Luckily, m m students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0 0 , all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

  1. If in i≠n , move from pile i i to pile i+1 i+1 ;
  2. If pile located at the position of student is not empty, remove one box from it.

GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time t t in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after t t seconds, but all the boxes must be removed.

输入格式

The first line contains two integers n n and m m ( 1<=n,m<=105 1<=n,m<=10^{5} ), the number of piles of boxes and the number of GukiZ's students.

The second line contains n n integers a1,a2,... an a_{1},a_{2},...\ a_{n} ( 0<=ai<=109 0<=a_{i}<=10^{9} ) where ai a_{i} represents the number of boxes on i i -th pile. It's guaranteed that at least one pile of is non-empty.

输出格式

In a single line, print one number, minimum time needed to remove all the boxes in seconds.

样例 #1

样例输入 #1

2 1
1 1

样例输出 #1

4

样例 #2

样例输入 #2

3 2
1 0 2

样例输出 #2

5

样例 #3

样例输入 #3

4 100
3 4 5 4

样例输出 #3

5

提示

First sample: Student will first move to the first pile ( 1 1 second), then remove box from first pile ( 1 1 second), then move to the second pile ( 1 1 second) and finally remove the box from second pile ( 1 1 second).

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 5 seconds.

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 5 seconds, when removing the boxes from the last pile is finished.